package com.bonus.material.task.mapper;

import java.util.Date;
import java.util.List;
import com.bonus.material.task.domain.TmTask;
import org.apache.ibatis.annotations.Param;

/**
 * 任务Mapper接口
 * 
 * @author xsheng
 * @date 2024-10-16
 */
public interface TmTaskMapper {
    /**
     * 查询任务
     * 
     * @param taskId 任务主键
     * @return 任务
     */
    TmTask selectTmTaskByTaskId(Long taskId);

    /**
     * 查询当年当月最大任务序号，用于生成任务编号 by 分类型查询
     * @param year 年
     * @param month 月
     * @param taskType 任务类型（字典表中获取，例如新购是:16）
     */
    int getMonthMaxOrderByDate(@Param("year") String year, @Param("month") String month, @Param("taskType") Integer taskType);

    /**
     * 查询任务列表
     * 
     * @param tmTask 任务
     * @return 任务集合
     */
    List<TmTask> selectTmTaskList(TmTask tmTask);

    /**
     * 新增任务
     * 
     * @param tmTask 任务
     * @return 结果
     */
    int insertTmTask(TmTask tmTask);

    /**
     * 修改任务
     * 
     * @param tmTask 任务
     * @return 结果
     */
    int updateTmTask(TmTask tmTask);

    /**
     * 根据任务id更新任务状态 -- 批量、限制状态
     * @param taskId 任务id  必传
     * @param newStatus 新状态
     */
    int updateTaskStatus(@Param("taskId") String taskId, @Param("newStatus") int newStatus);

    /**
     * 删除任务
     * 
     * @param taskId 任务主键
     * @return 结果
     */
    int deleteTmTaskByTaskId(Long taskId);

    /**
     * 批量删除任务
     * 
     * @param taskIds 需要删除的数据主键集合
     * @return 结果
     */
    int deleteTmTaskByTaskIds(Long[] taskIds);

    int deleteTmTaskByPurchaseIds(Long[] ids);

    /**
     * 获取任务编号
     *
     * @param nowDate
     * @param taskType
     * @return
     */
    String selectTaskNumByMonths(Date nowDate, Integer taskType);

}
